/**
  * =========================================================================
  *  Copyright (C) since 1995 by Leidson CAF & PlanetaMessenger.org
  *
  *  This module is developed and maintained by PlanetaMessenger.org. 
  *  Specs, New and updated versions can be found in 
  *  http://www.planetamessenger.org
  *  If you want contact the Team please send a email to Project Manager
  *  Leidson Campos Alves Ferreira at leidson@planetamessenger.org
  *
  *  Copyright (C) since 1995 by PlanetaMessenger.org
  *
  *  This program is free software; you can redistribute it and/or modify
  *  it under the terms of the GNU General Public License as published by
  *  the Free Software Foundation; either version 2 of the License, or
  *  (at your option) any later version.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  *  GNU General Public License for more details.
  *
  *  You should have received a copy of the GNU General Public License
  *  along with this program; if not, write to the Free Software
  *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  * ===========================================================================
  */

/**
  *
  * $Id: stringutil.cpp 52 2011-03-11 03:21:36Z popolony2k $
  * $Author: popolony2k $
  * $Date: 2011-03-11 03:21:36 +0000 (Fri, 11 Mar 2011) $
  * $Revision: 52 $
  * $HeadURL: file:///svn/p/oldskooltech/code/msx/trunk/tools/cpp/sound/mml2msd/stringutil.cpp $
  */

#include "stringutil.h"


/**
  * Trim spaces of std :: string;
  * @param str The String to trim spaces;
  */
void trim( std :: string& str ) {

  std :: string :: size_type nPos = str.find_last_not_of( ' ' );

  if( nPos != std :: string :: npos ) {
    str.erase( nPos + 1 );
    nPos = str.find_first_not_of( ' ' );

    if( nPos != std :: string :: npos )
      str.erase( 0, nPos );
  }
  else 
    str.erase( str.begin(), str.end() );
}

/**
  * Change the string to upper or lower case characters.
  * @param str The String to change case;
  */
void charcase( std :: string& str, CharCase charCase )  {

  std :: string     strTemp( "" );
  
  for( std :: string :: iterator itItem = str.begin(); itItem != str.end(); itItem++ )
    strTemp.insert( strTemp.end(), ( charCase == UPPERCASE ? toupper( *itItem ) : tolower( *itItem ) ) );
  
  str = strTemp;
}

/**
  * Remove specified character of string passed by parameter.
  * @param str The string to remove the character;
  * @param chChar The character to be removed;
  */
void remove( std :: string &str, char chChar )  {
  
  std :: string     strTemp( "" );
  
  for( std :: string :: iterator itItem = str.begin(); itItem != str.end(); itItem++ )
    if( *itItem != chChar )
      strTemp.insert( strTemp.end(), *itItem );
  
  str = strTemp;
}
